<?php

namespace Teknisa\CADFIS\Controllers; 

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO;
use Geral\Util\DateUtil;
use Teknisa\CADFIS\Controllers\TeknisaCrud;
use Teknisa\CADFIS\Services\Dfs47000ValorMaximoVendaConsumidorService;

class Dfs47000ValorMaximoVendaConsumidorController extends TeknisaCrud {
    
    public function __construct($crudService, $parameterBag, Dfs47000ValorMaximoVendaConsumidorService $Dfs47000ValorMaximoVendaConsumidorService){
        $this->Dfs47000ValorMaximoVendaConsumidorService = $Dfs47000ValorMaximoVendaConsumidorService;
    }

    public function saveVRMAXVENPROD(DTO\Request $request, DTO\Response $response){
        try{
            
            $row  = $request->getRow();
            $result = $this->Dfs47000ValorMaximoVendaConsumidorService->saveVRMAXVENPROD($row);
            
            $response->addDataSet(new DataSet('/result', [$result]));
            
        }catch(\Exception $e){
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }
    
    
    public function replicacaoValorMax(DTO\Request $request, DTO\Response $response){
        try{
            
            $row  = $request->getRow();
            $result = $this->Dfs47000ValorMaximoVendaConsumidorService->replicacaoValorMax($row, $response);
            
            $response->addDataSet(new DataSet('/result', [$result]));
            
        }catch(\Exception $e){
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }
    
    public function cadastramentoAutomatico(DTO\Request $request, DTO\Response $response){
        try{
            
            $row  = $request->getRow();
            $result = $this->Dfs47000ValorMaximoVendaConsumidorService->cadastramentoAutomatico($row);
            
            $response->addDataSet(new DataSet('/result', [$result]));
            
        }catch(\Exception $e){
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }
    
}