<?php
namespace Folha\Logic\Cadastros\SetupOrganizacao;

use Geral\Entities\Filioper;
use HCM\Util\DateUtil;

class FilialOperador{

    private $Nrorg;
    private $Dtinclusao;
    private $Nrorgfilial;
    private $Idativo;
    private $Cdoperador;
    private $Cdfilial;

    /************************************** GETTERS AND SETTERS ***********************************/

    private function setCdfilial($Cdfilial)
    {
        $this->Cdfilial = $Cdfilial;
    }

    private function setCdoperador($Cdoperador)
    {
        $this->Cdoperador = $Cdoperador;
    }

    private function setDtinclusao()
    {
        $this->Dtinclusao = DateUtil::getDataAtual()->format(DateUtil::FORMATO_BRASILEIRO);
    }

    private function setIdativo($Idativo)
    {
        $this->Idativo = $Idativo;
    }

    private function setNrorg($Nrorg)
    {
        $this->Nrorg = $Nrorg;
    }

    private function setNrorgfilial($Nrorgfilial)
    {
        $this->Nrorgfilial = $Nrorgfilial;
    }

    /**************************************** CONSTRUTOR ***************************************/

    private function __construct($Nrorg, $Cdoperador, $Nrorgfilial, $Idativo,  $Cdfilial){
        $this->setCdfilial($Cdfilial);
        $this->setCdoperador($Cdoperador);
        $this->setDtinclusao();
        $this->setIdativo($Idativo);
        $this->setNrorg($Nrorg);
        $this->setNrorgfilial($Nrorgfilial);
    }

    /**************************************** INSERSOR  ***************************************/

    private function add(){

        try {
            $filioper = new \FilioperEntity();

            $filioper->setCdfilial($this->Cdfilial);
            $filioper->setCdoperador($this->Cdoperador);
            $filioper->setDtinclusao($this->Cdoperador);
            $filioper->setNrorg($this->Nrorg);
            $filioper->setNrorgfilial($this->Nrorgfilial);

            \Filioper::inserirFilioper($filioper);

            return true;
        } catch (\Exception $e) {
            tk_message($e->getMessage(), 'error', true);
        }
    }
    /************************************* EXECUTOR DE INSERÇÃO *************************************/

    public static function cadastrar($Nrorg, $Cdoperador, $Nrorgfilial, $Idativo,  $Cdfilial){
        $filioper = new self($Nrorg, $Cdoperador, $Nrorgfilial, $Idativo,  $Cdfilial);
        return ($filioper->add());
    }
}